# Google Data APIs Client Library (1.43.0)

## com.google.gdata.data
Class OpenSearchDescriptionDocument

    java.lang.Object
      com.google.gdata.data.AbstractExtension
          com.google.gdata.data.ExtensionPoint
              com.google.gdata.data.OpenSearchDescriptionDocument

All Implemented Interfaces:
  Extension

    public class OpenSearchDescriptionDocument

extends ExtensionPoint

OpenSearch description document. See http://opensearch.a9.com/ for more information.

Nested Class Summary
`class` `OpenSearchDescriptionDocument.Handler` XmlParser ElementHandler for `openSearchDesc:OpenSearchDescription`
`static class` `OpenSearchDescriptionDocument.SyndicationRight` The SyndicationRight class defines constant values for syndication rights types.

Nested classes/interfaces inherited from class com.google.gdata.data.ExtensionPoint
`ExtensionPoint.CumulativeBlobHandler, ExtensionPoint.ExtensionHandler`

Nested classes/interfaces inherited from class com.google.gdata.data.AbstractExtension
`AbstractExtension.AttributesHandler`

Field Summary
`protected boolean` `adultContent` A boolean flag that must be set if the content provided is not suitable for minors.
`protected java.lang.String` `attribution` A list of all content sources or platforms that should be credited.
`protected java.lang.String` `contact` An email address at which the developer can be reached.
`protected java.lang.String` `description` A human readable text description of the search content provider.
`protected java.lang.String` `developer` The developer or maintainer of the OpenSearch feed.
`protected java.lang.String` `format` The XML schema used by the search engine specified by `url`.
`protected java.lang.String` `image` A URL that identifies the location of a 64x64-pixel image that can be used in association with this search engine.
`protected java.lang.String` `longName` The name by which this search content provider is referred to in hypertext links, etc.
`protected java.lang.String` `sampleSearch` A search string that should be used when example searches are done against this OpenSearch engine.
`protected java.lang.String` `shortName` A brief name that will appear in UI elements that reference this search content provider.
`protected int` `syndicationRight` The degree to which the search results provided by this search engine can be distributed.
`protected java.lang.String` `tags` A space-delimited set of words that are used as keywords to identify and categorize this search content.
`protected java.lang.String` `url` The HTTP GET URL at which the search content can be found.

Fields inherited from class com.google.gdata.data.ExtensionPoint
`xmlBlob`

Fields inherited from class com.google.gdata.data.AbstractExtension
`localName, namespace`

Constructor Summary
`OpenSearchDescriptionDocument()`
`OpenSearchDescriptionDocument(OpenSearchDescriptionDocument doc)`

Method Summary
`void` `generate(com.google.gdata.util.common.xml.XmlWriter w)` Generates XML.
`boolean` `getAdultContent()`
`java.lang.String` `getAttribution()`
`java.lang.String` `getContact()`
`java.lang.String` `getDescription()`
`java.lang.String` `getDeveloper()`
`java.lang.String` `getFormat()`
`java.lang.String` `getImage()`
`java.lang.String` `getLongName()`
`java.lang.String` `getSampleSearch()`
`java.lang.String` `getShortName()`
`int` `getSyndicationRight()`
`java.lang.String` `getTags()`
`java.lang.String` `getUrl()`
`void` `parse(ExtensionProfile extProfile, java.io.Reader reader)` Parses XML.
`void` `setAdultContent(boolean v)`
`void` `setAttribution(java.lang.String v)`
`void` `setContact(java.lang.String v)`
`void` `setDescription(java.lang.String v)`
`void` `setDeveloper(java.lang.String v)`
`void` `setFormat(java.lang.String v)`
`void` `setImage(java.lang.String v)`
`void` `setLongName(java.lang.String v)`
`void` `setSampleSearch(java.lang.String v)`
`void` `setShortName(java.lang.String v)`
`void` `setSyndicationRight(int v)`
`void` `setTags(java.lang.String v)`
`void` `setUrl(java.lang.String v)`
`void` `validateConfiguration()` Validates that the OpenSearchDescriptionDocument has all required properties.

Methods inherited from class com.google.gdata.data.ExtensionPoint

`addExtension, addExtension, addRepeatingExtension, addRepeatingExtension, checkRequiredExtensions, createExtensionInstance, declareExtensions, generate, generateCumulativeXmlBlob, generateExtensions, generateStartElement, getExtension, getExtensionDescription, getExtensionHandler, getExtensions, getHandler, getManifest, getRepeatingExtension, getRepeatingExtensions, getXmlBlob, hasExtension, hasRepeatingExtension, initializeArbitraryXml, parseCumulativeXmlBlob, removeExtension, removeExtension, removeRepeatingExtension, setExtension, setXmlBlob, visit, visitChild, visitChildren`

Methods inherited from class com.google.gdata.data.AbstractExtension
`consumeAttributes, disableStrictValidation, enableStrictValidation, eq, generate, generateAttributes, getExtensionLocalName, getExtensionNamespace, isImmutable, isStrictValidation, putAttributes, sameClassAs, setImmutable, throwExceptionForMissingAttribute, throwExceptionIfImmutable, validate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### url

    protected java.lang.String url

  The HTTP GET URL at which the search content can be found.

### format

    protected java.lang.String format

  The XML schema used by the search engine specified by `url`.

### shortName

    protected java.lang.String shortName

  A brief name that will appear in UI elements that reference this search content provider.

### longName

    protected java.lang.String longName

  The name by which this search content provider is referred to in hypertext links, etc.

### description

    protected java.lang.String description

  A human readable text description of the search content provider.

### tags

    protected java.lang.String tags

  A space-delimited set of words that are used as keywords to identify and categorize this search content.

### image

    protected java.lang.String image

  A URL that identifies the location of a 64x64-pixel image that can be used in association with this search engine.

### sampleSearch

    protected java.lang.String sampleSearch

  A search string that should be used when example searches are done against this OpenSearch engine.

### developer

    protected java.lang.String developer

  The developer or maintainer of the OpenSearch feed.

### contact

    protected java.lang.String contact

  An email address at which the developer can be reached.

### attribution

    protected java.lang.String attribution

  A list of all content sources or platforms that should be credited.

### syndicationRight

    protected int syndicationRight

  The degree to which the search results provided by this search engine can be distributed.

### adultContent

    protected boolean adultContent

  A boolean flag that must be set if the content provided is not suitable for minors.

Constructor Detail

### OpenSearchDescriptionDocument

    public OpenSearchDescriptionDocument()

### OpenSearchDescriptionDocument

    public OpenSearchDescriptionDocument(OpenSearchDescriptionDocument doc)

Method Detail

### getUrl

    public final java.lang.String getUrl()

### setUrl

    public void setUrl(java.lang.String v)

### getFormat

    public final java.lang.String getFormat()

### setFormat

    public void setFormat(java.lang.String v)

### getShortName

    public final java.lang.String getShortName()

### setShortName

    public void setShortName(java.lang.String v)

### getLongName

    public final java.lang.String getLongName()

### setLongName

    public void setLongName(java.lang.String v)

### getDescription

    public final java.lang.String getDescription()

### setDescription

    public void setDescription(java.lang.String v)

### getTags

    public final java.lang.String getTags()

### setTags

    public void setTags(java.lang.String v)

### getImage

    public final java.lang.String getImage()

### setImage

    public void setImage(java.lang.String v)

### getSampleSearch

    public final java.lang.String getSampleSearch()

### setSampleSearch

    public void setSampleSearch(java.lang.String v)

### getDeveloper

    public final java.lang.String getDeveloper()

### setDeveloper

    public void setDeveloper(java.lang.String v)

### getContact

    public final java.lang.String getContact()

### setContact

    public void setContact(java.lang.String v)

### getAttribution

    public final java.lang.String getAttribution()

### setAttribution

    public void setAttribution(java.lang.String v)

### getSyndicationRight

    public final int getSyndicationRight()

### setSyndicationRight

    public void setSyndicationRight(int v)

### getAdultContent

    public final boolean getAdultContent()

### setAdultContent

    public void setAdultContent(boolean v)

### generate

    public void generate(com.google.gdata.util.common.xml.XmlWriter w)
                  throws java.io.IOException

  Generates XML.

  Parameters:
    `w` - output writer
  Throws:
    `java.io.IOException`

### validateConfiguration

    public void validateConfiguration()
                               throws ServiceConfigurationException

  Validates that the OpenSearchDescriptionDocument has all required properties. The one exception is the `url` property, which is dynamically generated based upon the feed that is queried.

  Throws:
    `ServiceConfigurationException`

### parse

    public void parse(ExtensionProfile extProfile,
                      java.io.Reader reader)
               throws java.io.IOException,
                      ParseException

  Parses XML.

  Parameters:
    `extProfile` - extension profile
    `reader` - XML input stream
  Throws:
    `java.io.IOException`
    `ParseException`